PivotTable offers the ability to add a calculated field with a formula
It also supports removing calculated field.
You can get all calculated fields that are set in the specified PivotTable.
The returned result has two properties:
fieldName: the calculated field name.
formula: the formula of the calculated field name.
window.onload = function () {
let spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), {sheetCount: 2});
initSpread(spread);
};
function initSpread(spread) {
spread.suspendPaint();
let sheet1 = spread.getSheet(0);
let sheet2 = spread.getSheet(1);
let tableName = getDataSource(sheet2, pivotSales);
let pivotTable = initPivotTable(sheet1, tableName);
bindEvent(spread, pivotTable);
spread.resumePaint();
}
function getDataSource(sheet, tableSource){
sheet.name("DataSource");
sheet.setRowCount(117);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1,4,0,2).formatter("$ #,##0");
let table = sheet.tables.add('table', 0, 0, 117, 6);
for(let i=2;i<=117;i++)
{
sheet.setFormula(i-1,5,'=D'+i+'*E'+i)
}
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
sheet.setArray(0, 0, tableSource);
return table.name();
}
function initPivotTable(sheet, source){
sheet.suspendPaint();
sheet.name("PivotTable");
sheet.setRowCount(1000);
sheet.setColumnCount(100);
let option = {
showRowHeader: true,
showColumnHeader: true,
bandRows: true,
bandColumns: true
};
let pivotTable = sheet.pivotTables.add("PivotTable", source, 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8, option);
pivotTable.suspendLayout();
pivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
pivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField);
pivotTable.add("date", "Qt", GC.Spread.Pivot.PivotTableFieldType.columnField);
let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] };
pivotTable.group(groupInfo);
pivotTable.add("total", "Revenue", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pivotTable.addCalcField('tax', '=total * 0.08');
pivotTable.add("tax", "Tax", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pivotTable.resumeLayout();
sheet.resumePaint();
pivotTable.autoFitColumn();
return pivotTable;
}
function bindEvent(spread, pivotTable){
document.getElementById("add-calc-field").addEventListener("click", function(event){
pivotTable.suspendLayout();
let fieldName = document.getElementById("fieldName").value;
let formula = document.getElementById("formula").value;
pivotTable.addCalcField(fieldName, formula);
pivotTable.add(fieldName, fieldName, GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pivotTable.resumeLayout();
});
document.getElementById("remove-calc-field").addEventListener("click", function(event){
pivotTable.suspendLayout();
let fieldName = document.getElementById("fieldName").value;
pivotTable.removeCalcField(fieldName);
pivotTable.resumeLayout();
});
document.getElementById("list-calc-fields").addEventListener("click", function(event){
spread.suspendPaint();
var sheet = new GC.Spread.Sheets.Worksheet();
var sheetCount = spread.getSheetCount();
spread.addSheet(sheetCount, sheet);
sheet.setColumnWidth(0,150);
sheet.setColumnWidth(1,150);
sheet.setValue(0, 0, "Field Name");
sheet.setValue(0, 1, "Formula");
var calcFieldInfos = pivotTable.getCalcFields();
for (var i = 0; i < calcFieldInfos.length; i++) {
sheet.setValue(i + 1, 0, calcFieldInfos[i].fieldName);
sheet.setValue(i + 1, 1, calcFieldInfos[i].formula);
}
spread.setActiveSheet(sheet.name());
spread.resumePaint();
});
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@grapecity/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/purejs/node_modules/@grapecity/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@grapecity/spread-sheets-shapes/dist/gc.spread.sheets.shapes.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@grapecity/spread-sheets-pivot-addon/dist/gc.spread.pivot.pivottables.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/data/data.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
<div id="container" class="options-container">
<div>
<div class = "select-option-class">Field Name:</div>
<input type="text" name="" id="fieldName" class="missingCaption select-option-select"/>
</div>
<div>
<div class = "select-option-class">Formula:</div>
<input type="text" name="" id="formula" class="rowLabelIndent select-option-select"/>
</div>
<hr />
<div>
<label class = "select-option-class">- To add a Calculated Field enter Field Name and Formula and click the below button.</label>
<label class = "select-option-class"><u>For Example</u>: Add <b>Commission</b> to field name, and <b>=total*0.05</b> to formula, to have a calculated field for Commission. You can find the inserted fields after the current ones (at columns L-O and R).</label>
</div>
<input type="button" value="Add Calculated Field" class="set-option" id="add-calc-field" />
<div>
<label class = "select-option-class">- To remove a Calculated Field, enter the name in the Field Name box and click the below button.</label>
<label class = "select-option-class"><u>For Example</u>: Tax.</label>
</div>
<input type="button" value="Remove Calculated Field" class="set-option" id="remove-calc-field" />
<div>
<label class = "select-option-class">- Click the List Calculated Fields to see the list of all Calculated Fields that have been created.</label>
</div>
<input type="button" value="List Calculated Fields" class="set-option" id="list-calc-fields" />
</div>
</div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 300px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 300px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.set-option {
display: block;
margin-top: 20px;
width: 250px;
}
#reportFilterFieldsPerColumn {
width: 28px;
}
.select-option-class{
display: block;
margin-top: 10px;
margin-bottom: 10px
}
.select-option-select{
width: 250px;
display: block;
margin-bottom: 20px;
}
.option-item{
display: block;
height: 20px;
margin-bottom: 20px;
}

PivotTable offers the ability to add a calculated field with a formula
It also supports removing calculated field.
You can get all calculated fields that are set in the specified PivotTable.
The returned result has two properties:
fieldName: the calculated field name.
formula: the formula of the calculated field name.
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-pivot-addon";
import { SpreadSheets } from '@mescius/spread-sheets-react';
import './styles.css';
const useState = React.useState;
export function AppFunc() {
const [spread, setSpread] = useState(null);
const [pivotTable, setPivotTable] = useState(null);
const [fieldName, setFieldName] = useState('');
const [formula, setFormula] = useState('');
const handleFieldName = (event) => {
setFieldName(event.target.value)
}
const handleFormula = (event) => {
setFormula(event.target.value)
}
const addCalcField = () => {
pivotTable.suspendLayout();
pivotTable.addCalcField(fieldName, formula);
pivotTable.add(fieldName, fieldName, GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pivotTable.resumeLayout();
}
const removeCalcField = () => {
pivotTable.suspendLayout();
pivotTable.removeCalcField(fieldName);
pivotTable.resumeLayout();
}
const listFormula = () => {
spread.suspendPaint();
let sheet = new GC.Spread.Sheets.Worksheet();
let sheetCount = spread.getSheetCount();
spread.addSheet(sheetCount, sheet);
sheet.setColumnWidth(0, 150);
sheet.setColumnWidth(1, 150);
sheet.setValue(0, 0, "Field Name");
sheet.setValue(0, 1, "Formula");
let calcFieldInfos = pivotTable.getCalcFields();
for (let i = 0; i < calcFieldInfos.length; i++) {
sheet.setValue(i + 1, 0, calcFieldInfos[i].fieldName);
sheet.setValue(i + 1, 1, calcFieldInfos[i].formula);
}
spread.setActiveSheet(sheet.name());
spread.resumePaint();
}
const initSpread = (spread) => {
setSpread(spread);
spread.suspendPaint();
spread.setSheetCount(2);
let sheet1 = spread.getSheet(0);
let sheet2 = spread.getSheet(1);
let tableName = getDataSource(sheet2, pivotSales);
let pt = initPivotTable(sheet1, tableName);
setPivotTable(pt);
spread.resumePaint();
}
const getDataSource = (sheet, tableSource) => {
sheet.name("DataSource");
sheet.setRowCount(117);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1, 4, 0, 2).formatter("$ #,##0");
let table = sheet.tables.add('table', 0, 0, 117, 6);
for (let i = 2; i <= 117; i++) {
sheet.setFormula(i - 1, 5, '=D' + i + '*E' + i)
}
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
sheet.setArray(0, 0, tableSource);
return table.name();
}
const initPivotTable = (sheet, source) => {
sheet.suspendPaint();
sheet.name("PivotTable");
sheet.setRowCount(1000);
sheet.setColumnCount(100);
sheet.setColumnWidth(0, 20);
let option = {
showRowHeader: true,
showColumnHeader: true,
bandRows: true,
bandColumns: true
};
let pt = sheet.pivotTables.add("PivotTable", source, 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8, option);
pt.suspendLayout();
pt.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
pt.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField);
let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] };
pt.group(groupInfo);
pt.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.columnField);
pt.add("total", "Revenue", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pt.addCalcField('tax', '=total * 0.08');
pt.add("tax", "Tax", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pt.resumeLayout();
sheet.resumePaint();
pt.autoFitColumn();
return pt;
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
</SpreadSheets>
</div>
<div id="container" class="options-container">
<div>
<div class="select-option-class">Field Name:</div>
<input type="text" name="" id="fieldName" class="missingCaption select-option-select" value={fieldName} onChange={handleFieldName} />
</div>
<div>
<div class="select-option-class">Formula:</div>
<input type="text" name="" id="formula" class="rowLabelIndent select-option-select" value={formula} onChange={handleFormula} />
</div>
<hr />
<div>
<label class="select-option-class">- To add a Calculated Field enter Field Name and Formula and click the below button.</label>
<label class="select-option-class"><u>For Example</u>: Add <b>Commission</b> to field name, and <b>=total*0.05</b> to formula, to have a calculated field for Commission. You can find the inserted fields after the current ones (at columns L-O and R).</label>
</div>
<input type="button" value="Add Calculated Field" className="set-option" id="add-calc-field" onClick={addCalcField} />
<div>
<label class="select-option-class">- To remove a Calculated Field, enter the name in the Field Name box and click the below button.</label>
<label class="select-option-class"><u>For Example</u>: Tax.</label>
</div>
<input type="button" value="Remove Calculated Field" className="set-option" id="remove-calc-field" onClick={removeCalcField} />
<div>
<label class="select-option-class">- Click the List Calculated Fields to see the list of all Calculated Fields that have been created.</label>
</div>
<input type="button" value="List Calculated Fields" className="set-option" id="list-calc-fields" onClick={listFormula} />
</div>
</div>
);
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-pivot-addon";
import { SpreadSheets } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.state = {
fieldName: '',
formula: ''
};
this.handleFieldName = this.handleFieldName.bind(this);
this.handleFormula = this.handleFormula.bind(this);
this.addCalcField = this.addCalcField.bind(this);
this.removeCalcField = this.removeCalcField.bind(this);
this.listFormula = this.listFormula.bind(this);
}
handleFieldName(event) {
this.setState({ fieldName: event.target.value });
}
handleFormula(event) {
this.setState({ formula: event.target.value });
}
addCalcField() {
let pivotTable = this.pivotTable;
pivotTable.suspendLayout();
let fieldName = this.state.fieldName;
let formula = this.state.formula;
pivotTable.addCalcField(fieldName, formula);
pivotTable.add(fieldName, fieldName, GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pivotTable.resumeLayout();
}
removeCalcField() {
let pivotTable = this.pivotTable;
pivotTable.suspendLayout();
let fieldName = this.state.fieldName;
pivotTable.removeCalcField(fieldName);
pivotTable.resumeLayout();
}
listFormula() {
let spread = this.spread, pivotTable = this.pivotTable;
spread.suspendPaint();
let sheet = new GC.Spread.Sheets.Worksheet();
let sheetCount = spread.getSheetCount();
spread.addSheet(sheetCount, sheet);
sheet.setColumnWidth(0, 150);
sheet.setColumnWidth(1, 150);
sheet.setValue(0, 0, "Field Name");
sheet.setValue(0, 1, "Formula");
let calcFieldInfos = pivotTable.getCalcFields();
for (let i = 0; i < calcFieldInfos.length; i++) {
sheet.setValue(i + 1, 0, calcFieldInfos[i].fieldName);
sheet.setValue(i + 1, 1, calcFieldInfos[i].formula);
}
spread.setActiveSheet(sheet.name());
spread.resumePaint();
}
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
</SpreadSheets>
</div>
<div id="container" class="options-container">
<div>
<div class="select-option-class">Field Name:</div>
<input type="text" name="" id="fieldName" class="missingCaption select-option-select" value={this.state.fieldName} onChange={this.handleFieldName} />
</div>
<div>
<div class="select-option-class">Formula:</div>
<input type="text" name="" id="formula" class="rowLabelIndent select-option-select" value={this.state.formula} onChange={this.handleFormula} />
</div>
<hr />
<div>
<label class="select-option-class">- To add a Calculated Field enter Field Name and Formula and click the below button.</label>
<label class="select-option-class"><u>For Example</u>: Add <b>Commission</b> to field name, and <b>=total*0.05</b> to formula, to have a calculated field for Commission. You can find the inserted fields after the current ones (at columns L-O and R).</label>
</div>
<input type="button" value="Add Calculated Field" className="set-option" id="add-calc-field" onClick={this.addCalcField} />
<div>
<label class="select-option-class">- To remove a Calculated Field, enter the name in the Field Name box and click the below button.</label>
<label class="select-option-class"><u>For Example</u>: Tax.</label>
</div>
<input type="button" value="Remove Calculated Field" className="set-option" id="remove-calc-field" onClick={this.removeCalcField} />
<div>
<label class="select-option-class">- Click the List Calculated Fields to see the list of all Calculated Fields that have been created.</label>
</div>
<input type="button" value="List Calculated Fields" className="set-option" id="list-calc-fields" onClick={this.listFormula} />
</div>
</div>
);
}
initSpread(spread) {
this.spread = spread;
spread.suspendPaint();
spread.setSheetCount(2);
let sheet1 = spread.getSheet(0);
let sheet2 = spread.getSheet(1);
let tableName = this.getDataSource(sheet2, pivotSales);
let pivotTable = this.initPivotTable(sheet1, tableName);
this.pivotTable = pivotTable;
spread.resumePaint();
}
getDataSource(sheet, tableSource) {
sheet.name("DataSource");
sheet.setRowCount(117);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1, 4, 0, 2).formatter("$ #,##0");
let table = sheet.tables.add('table', 0, 0, 117, 6);
for (let i = 2; i <= 117; i++) {
sheet.setFormula(i - 1, 5, '=D' + i + '*E' + i)
}
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
sheet.setArray(0, 0, tableSource);
return table.name();
}
initPivotTable(sheet, source) {
sheet.suspendPaint();
sheet.name("PivotTable");
sheet.setRowCount(1000);
sheet.setColumnCount(100);
sheet.setColumnWidth(0, 20);
let option = {
showRowHeader: true,
showColumnHeader: true,
bandRows: true,
bandColumns: true
};
let pivotTable = sheet.pivotTables.add("PivotTable", source, 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8, option);
pivotTable.suspendLayout();
pivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
pivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField);
let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] };
pivotTable.group(groupInfo);
pivotTable.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.columnField);
pivotTable.add("total", "Revenue", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pivotTable.addCalcField('tax', '=total * 0.08');
pivotTable.add("tax", "Tax", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pivotTable.resumeLayout();
sheet.resumePaint();
pivotTable.autoFitColumn();
return pivotTable;
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 300px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 300px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.set-option {
display: block;
margin-top: 20px;
width: 250px;
}
#reportFilterFieldsPerColumn {
width: 28px;
}
.select-option-class{
display: block;
margin-top: 10px;
margin-bottom: 10px
}
.select-option-select{
width: 250px;
display: block;
margin-bottom: 20px;
}
.option-item{
display: block;
height: 20px;
margin-bottom: 20px;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

PivotTable offers the ability to add a calculated field with a formula
It also supports removing calculated field.
You can get all calculated fields that are set in the specified PivotTable.
The returned result has two properties:
fieldName: the calculated field name.
formula: the formula of the calculated field name.
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread"> </gc-spread-sheets>
<div id="container" class="options-container">
<div>
<div class="select-option-class">Field Name:</div>
<input type="text" name="" id="fieldName" class="missingCaption select-option-select" v-model="fieldNameRef" />
</div>
<div>
<div class = "select-option-class">Formula:</div>
<input type="text" name="" id="formula" class="rowLabelIndent select-option-select" v-model="formulaRef"/>
</div>
<hr />
<div>
<label class = "select-option-class">- To add a Calculated Field enter Field Name and Formula and click the below button.</label>
<label class = "select-option-class"><u>For Example</u>: Add <b>Commission</b> to field name, and <b>=total*0.05</b> to formula, to have a calculated field for Commission. You can find the inserted fields after the current ones (at columns L-O and R).</label>
</div>
<input type="button" value="Add Calculated Field" class="set-option" id="add-calc-field" @click="addCalcField()" />
<div>
<label class = "select-option-class">- To remove a Calculated Field, enter the name in the Field Name box and click the below button.</label>
<label class = "select-option-class"><u>For Example</u>: Tax.</label>
</div>
<input type="button" value="Remove Calculated Field" class="set-option" id="remove-calc-field" @click="removeCalcField()" />
<div>
<label class = "select-option-class">- Click the List Calculated Fields to see the list of all Calculated Fields that have been created.</label>
</div>
<input type="button" value="List Calculated Fields" class="set-option" id="list-calc-fields" @click="listFormula()" />
</div>
</div>
</template>
<script setup>
import GC from "@mescius/spread-sheets";
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-vue";
import { shallowRef } from "vue";
import "@mescius/spread-sheets-pivot-addon";
let spreadRef = shallowRef(null);
let pivotTableRef = shallowRef(null);
let fieldNameRef = shallowRef("");
let formulaRef = shallowRef("");
async function initSpread(spread) {
spreadRef.value = spread;
spread.suspendPaint();
spread.setSheetCount(2);
let sheet1 = spread.getSheet(0);
let sheet2 = spread.getSheet(1);
let tableName = getDataSource(sheet2, pivotSales);
let pivotTable = initPivotTable(sheet1, tableName);
pivotTableRef.value = pivotTable;
spread.resumePaint();
}
function addCalcField () {
let pivotTable = pivotTableRef.value;
pivotTable.suspendLayout();
let fieldName = fieldNameRef.value;
let formula = formulaRef.value;
pivotTable.addCalcField(fieldName, formula);
pivotTable.add(fieldName, fieldName, GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pivotTable.resumeLayout();
}
function removeCalcField () {
let pivotTable = pivotTableRef.value;
pivotTable.suspendLayout();
let fieldName = fieldNameRef.value;
pivotTable.removeCalcField(fieldName);
pivotTable.resumeLayout();
}
function listFormula () {
let spread = spreadRef.value, pivotTable = pivotTableRef.value;
spread.suspendPaint();
let sheet = new GC.Spread.Sheets.Worksheet();
let sheetCount = spread.getSheetCount();
spread.addSheet(sheetCount, sheet);
sheet.setColumnWidth(0,150);
sheet.setColumnWidth(1,150);
sheet.setValue(0, 0, "Field Name");
sheet.setValue(0, 1, "Formula");
let calcFieldInfos = pivotTable.getCalcFields();
for (let i = 0; i < calcFieldInfos.length; i++) {
sheet.setValue(i + 1, 0, calcFieldInfos[i].fieldName);
sheet.setValue(i + 1, 1, calcFieldInfos[i].formula);
}
spread.setActiveSheet(sheet.name());
spread.resumePaint();
}
function getDataSource (sheet, tableSource) {
sheet.name("DataSource");
sheet.setRowCount(117);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1,4,0,2).formatter("$ #,##0");
let table = sheet.tables.add('table', 0, 0, 117, 6);
for(let i=2;i<=117;i++)
{
sheet.setFormula(i-1,5,'=D'+i+'*E'+i)
}
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
sheet.setArray(0, 0, tableSource);
return table.name();
}
function initPivotTable (sheet, source) {
sheet.suspendPaint();
sheet.name("PivotTable");
sheet.setRowCount(1000);
sheet.setColumnCount(100);
let option = {
showRowHeader: true,
showColumnHeader: true,
bandRows: true,
bandColumns: true
};
let pivotTable = sheet.pivotTables.add("PivotTable", source, 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8, option);
pivotTable.suspendLayout();
pivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
pivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField);
let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] };
pivotTable.group(groupInfo);
pivotTable.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.columnField);
pivotTable.add("total", "Revenue", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pivotTable.addCalcField('tax', '=total * 0.08');
pivotTable.add("tax", "Tax", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pivotTable.resumeLayout();
sheet.resumePaint();
pivotTable.autoFitColumn();
return pivotTable;
}
</script>
<style scoped>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 300px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 300px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
font-size: 14px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.set-option {
display: block;
margin-top: 20px;
width: 250px;
}
#reportFilterFieldsPerColumn {
width: 28px;
}
.select-option-class{
display: block;
margin-top: 10px;
margin-bottom: 10px
}
.select-option-select{
width: 250px;
display: block;
margin-bottom: 20px;
}
.option-item{
display: block;
height: 20px;
margin-bottom: 20px;
}
#app {
height: 100%;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'../node_modules/*/package.json',
"../node_modules/@mescius/*/package.json",
"../node_modules/@babel/*/package.json",
"../node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-en': 'npm:@mescius/spread-sheets-resources-en/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
'@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

PivotTable offers the ability to add a calculated field with a formula
It also supports removing calculated field.
You can get all calculated fields that are set in the specified PivotTable.
The returned result has two properties:
fieldName: the calculated field name.
formula: the formula of the calculated field name.
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import { FormsModule } from '@angular/forms';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-pivot-addon";
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
autoGenerateColumns = false;
autoMergeMode = GC.Spread.Sheets.AutoMerge.AutoMergeMode.restricted;
autoMergeSelectionMode = GC.Spread.Sheets.AutoMerge.SelectionMode.merged;
dataSource: any[];
spread: GC.Spread.Sheets.Workbook;
fieldName: string;
formula: string;
pivotTable: any;
hostStyle = {
width: 'calc(100% - 300px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
this.fieldName = "";
this.formula = "";
}
initSpread($Event: any) {
let spread = $Event.spread;
this.spread = spread;
spread.suspendPaint();
spread.setSheetCount(2);
let sheet1 = spread.getSheet(0);
let sheet2 = spread.getSheet(1);
let tableName = this.getDataSource(sheet2, pivotSales);
let pivotTable = this.initPivotTable(sheet1, tableName);
this.pivotTable = pivotTable;
spread.resumePaint();
}
getDataSource(sheet: GC.Spread.Sheets.Workbook, tableSource: any) {
sheet.name("DataSource");
sheet.setRowCount(117);
sheet.setColumnWidth(0, 120);
sheet.getCell(-1, 0).formatter("YYYY-mm-DD");
sheet.getRange(-1,4,0,2).formatter("$ #,##0");
let table = sheet.tables.add('table', 0, 0, 117, 6);
for(let i=2;i<=117;i++)
{
sheet.setFormula(i-1,5,'=D'+i+'*E'+i)
}
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
sheet.setArray(0, 0, tableSource);
return table.name();
}
initPivotTable(sheet: GC.Spread.Sheets.Workbook, source: any) {
sheet.suspendPaint();
sheet.name("PivotTable");
sheet.setRowCount(1000);
sheet.setColumnCount(100);
let option = {
showRowHeader: true,
showColumnHeader: true,
bandRows: true,
bandColumns: true
};
let pivotTable = sheet.pivotTables.add("PivotTable", source, 1, 1, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8, option);
pivotTable.suspendLayout();
pivotTable.add("salesperson", "Salesperson", GC.Spread.Pivot.PivotTableFieldType.rowField);
pivotTable.add("car", "Cars", GC.Spread.Pivot.PivotTableFieldType.rowField);
let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }] };
pivotTable.group(groupInfo);
pivotTable.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.columnField);
pivotTable.add("total", "Revenue", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pivotTable.addCalcField('tax', '=total * 0.08');
pivotTable.add("tax", "Tax", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pivotTable.resumeLayout();
sheet.resumePaint();
pivotTable.autoFitColumn();
return pivotTable;
}
addCalculatedField () {
let pivotTable = this.pivotTable;
pivotTable.suspendLayout();
let fieldName = this.fieldName;
let formula = this.formula;
pivotTable.addCalcField(fieldName, formula);
pivotTable.add(fieldName, fieldName, GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pivotTable.resumeLayout();
}
removeCalculatedField () {
let pivotTable = this.pivotTable;
pivotTable.suspendLayout();
let fieldName = this.fieldName;
pivotTable.removeCalcField(fieldName);
pivotTable.resumeLayout();
}
listCalculatedFields () {
let spread = this.spread, pivotTable = this.pivotTable;
spread.suspendPaint();
let sheet = new GC.Spread.Sheets.Worksheet();
let sheetCount = spread.getSheetCount();
spread.addSheet(sheetCount, sheet);
sheet.setColumnWidth(0,150);
sheet.setColumnWidth(1,150);
sheet.setValue(0, 0, "Field Name");
sheet.setValue(0, 1, "Formula");
let calcFieldInfos = pivotTable.getCalcFields();
for (let i = 0; i < calcFieldInfos.length; i++) {
sheet.setValue(i + 1, 0, calcFieldInfos[i].fieldName);
sheet.setValue(i + 1, 1, calcFieldInfos[i].formula);
}
spread.setActiveSheet(sheet.name());
spread.resumePaint();
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/pivot-data.js" type="text/javascript"></script>
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
</gc-spread-sheets>
<div id="container" class="options-container">
<div>
<div class = "select-option-class">Field Name:</div>
<input type="text" name="" id="fieldName" class="missingCaption select-option-select" [(ngModel)]="fieldName">
</div>
<div>
<div class = "select-option-class">Formula:</div>
<input type="text" name="" id="formula" class="rowLabelIndent select-option-select" [(ngModel)]="formula">
</div>
<hr />
<div>
<label class = "select-option-class">- To add a Calculated Field enter Field Name and Formula and click the below button.</label>
<label class = "select-option-class"><u>For Example</u>: Add <b>Commission</b> to field name, and <b>=total*0.05</b> to formula, to have a calculated field for Commission. You can find the inserted fields after the current ones (at columns L-O and R).</label>
</div>
<input type="button" value="Add Calculated Field" class="set-option" id="add-calc-field" (click)="addCalculatedField()">
<div>
<label class = "select-option-class">- To remove a Calculated Field, enter the name in the Field Name box and click the below button.</label>
<label class = "select-option-class"><u>For Example</u>: Tax.</label>
</div>
<input type="button" value="Remove Calculated Field" class="set-option" id="remove-calc-field" (click)="removeCalculatedField()">
<div>
<label class = "select-option-class">- Click the List Calculated Fields to see the list of all Calculated Fields that have been created.</label>
</div>
<input type="button" value="List Calculated Fields" class="set-option" id="list-calc-fields" (click)="listCalculatedFields()">
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 300px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 300px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.set-option {
display: block;
margin-top: 20px;
width: 250px;
}
#reportFilterFieldsPerColumn {
width: 28px;
}
.select-option-class{
display: block;
margin-top: 10px;
margin-bottom: 10px
}
.select-option-select{
width: 250px;
display: block;
margin-bottom: 20px;
}
.option-item{
display: block;
height: 20px;
margin-bottom: 20px;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);